//+------------------------------------------------------------------+
//|                                                IncERDOnArray.mqh |
//|                                                          Integer |
//|                          https://login.mql5.com/en/users/Integer |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link      "https://login.mql5.com/en/users/Integer"
#property version   "1.00"
/*
   External parameters:
   input int  ERDPeriod=34;

   Declaration:
   #include <IncOnArray/IncERDOnArray.mqh>
   CERDOnArray er;

   In OnInit:  
   er.Init(ERDPeriod);

   In OnCalculate:
   er.Solve(rates_total,prev_calculated,data,ERBuffer); 
*/
//+------------------------------------------------------------------+
//| CERDOnArray                                                      |
//+------------------------------------------------------------------+
class CERDOnArray
  {
private:
   int               m_Period;
   int               m_br;
   string            m_Name;
public:
   void Init(int aPeriod=34)
     {
      m_Period=aPeriod;
      m_Name="ERD("+IntegerToString(m_Period)+")";
      m_br=m_Period;
     }
   void Solve(const int aRatesTotal,
              const int aPrevCalc,
              double  &aData[],
              double  &aERD[])
     {
      int Start=0;
      if(aPrevCalc==0)
        {
         for(int i=0;i<aRatesTotal;i++)
           {
            if(aData[i]!=0 && aData[i]!=EMPTY_VALUE)
              {
               Start=i+m_Period;
               break;
              }
           }
        }
      else
        {
         Start=aPrevCalc-1;
        }
      for(int i=Start;i<aRatesTotal;i++)
        {
         double m_a=aData[i]-aData[i-m_Period];
         double m_b=0;
         for(int j=i;j>i-m_Period;j--)
           {
            m_b+=MathAbs(aData[j]-aData[j-1]);
           }
         if(m_b!=0)
           {
            aERD[i]=m_a/m_b;
           }
         else
           {
            aERD[i]=aERD[i-1];
           }
        }
     }
   int BarsRequired()
     {
      return(m_br);
     }
   string Name()
     {
      return(m_Name);
     }
   string About()
     {
      return("Integer's ERDOnArray class. https://login.mql5.com/en/users/Integer");
     }
  };
//+------------------------------------------------------------------+
